/**
 * Компонент для отображения информации - внимание
 */
(function() {
    'use strict';
    angular
        .module('starter')
        .component('infoTextUpd', {
            templateUrl: 'components/infoTextUpd/infoTextUpd.html',
            controller: infoMenuController,
            bindings: {
                url: '=', // url основного запроса
                texttop: '=',
                text2: '<',
                bgclass: '='
            }
        });
    // lgray-bg
    // инжекции в контроллер
    infoMenuController.inject = ['$rootScope'];

    /**
     * контроллер для компонента
     * @param {object} $scope
     * @param {element} $element
     * @param {object} $attrs
     * @param {object} $rootScope
     */
    function infoMenuController($scope, $element, $attrs, $rootScope, $sce) {
        var ctrl = this;
        /**
         * Инициализация
         */
        ctrl.$onInit = function() {
            $scope.url = ctrl.url;
            $scope.textTop = ctrl.texttop;
            $scope.text2 = $sce.trustAsHtml(ctrl.text2);
            $scope.inClass = ctrl.bgclass;

        };
        ctrl.$onChanges = function(changesObj) {
            console.log(changesObj);
            if (changesObj.text2) {
                $scope.text2 = changesObj.text2.currentValue;
            }
        };
    }
})()