/**
 * Компонент отпуска подчиненных
 */
(function() {
    'use strict';
    angular
        .module('starter')
        .component('leaveFact', {
            templateUrl: 'components/leaveStaff/leaveFact.html',
            controller: leaveFactController,
            bindings: {
                url: '=', // url основного запроса
                token: '=',
                fndstr: '<', // строка для поиска
                person: '=', // person_id
                position: '=', // position_id
                findmode: '<'
            }
        });
    // url p_token=" + token + '&p_position_id=' + position +
    // '&p_person_id=' + person + "&p_date=" + $scope.startMon
    // инжекции в контроллер
    leaveFactController.inject = ['$rootScope', '$http'];

    /**
     * контроллер для компонента
     * @param {object} $scope
     * @param {element} $element
     * @param {object} $attrs
     * @param {object} $rootScope
     * @param {object} $http
     */
    function leaveFactController($scope, $element, $attrs, $rootScope, $http, MonthPicker, mHttpGet) {
        var ctrl = this;
        /**
         * Инициализация
         */
        ctrl.$onInit = function() {
            $scope.fndStr = ctrl.fndstr;
            $scope.startMon = moment().format('DD.MM.YYYY');
            $scope.find = { str: "", mode: "N" };
            moment.locale('ru');
            $scope.showLegend = 'Y';
            $scope.startMon = moment().format('DD.MM.YYYY');
            $scope.mon = moment().format('MMMM') + ' ' + moment().format('YYYY');
            $scope.LeaveDataShow = {};
            $scope.LeaveDataShow.pers = [];
            $scope.partPosition = 0;
            $scope.LeaveData = {};
            MonthPicker.init({
                title: "Выберите месяц",
                cancelText: "Отмена",
                cancelClass: 'button-positive',
                monthLabels: ['Янв', 'Фев', 'Мар', 'Апр', 'Май', 'Июн', 'Июл', 'Авг', 'Сен', 'Окт', 'Ноя', 'Дек'],
                minMonthIndex: 0,
                maxMonthIndex: 11,
                minYear: new Date().getFullYear() - 1,
                maxYear: new Date().getFullYear() + 1,
                startingYear: new Date().getFullYear()
            });
            $scope.getdata(ctrl.url, ctrl.token, ctrl.person, ctrl.position, ctrl.person)
        };
        ctrl.$onChanges = function(changesObj) {
            console.log(changesObj);
            if (changesObj.findmode) {
                $scope.find.mode = changesObj.findmode.currentValue;
                if ($scope.find.mode == 'N') {
                    $scope.find.str = '';
                }
            }
            if (changesObj.fndstr) {
                if ($scope.find.mode == 'Y') {
                    $scope.find.str = changesObj.fndstr.currentValue;
                }
            }
        };
        /**
         * Уничтожение компонента
         */
        ctrl.$onDestroy = function() {}
        $scope.buttonTap = function() {
            $scope.moredata = true;
            $scope.LeaveDataShow = {};
            $scope.LeaveDataShow.pers = [];
            $scope.partPosition = 0;
            $scope.LeaveData = {};
            MonthPicker.show(function(res) {
                console.log(res);
                $scope.startMon = '01.' + (res.month + 1) + '.' + res.year;
                console.log($scope.startMon);
                $scope.mon = moment('01.' + (res.month + 1) + '.' + res.year, 'DD.MM.YYYY').format('MMMM') 
                            + ' ' + moment('01.' + (res.month + 1) + '.' + res.year, 'DD.MM.YYYY').format('YYYY');
                $scope.getdata(ctrl.url, ctrl.token, ctrl.person, ctrl.position, ctrl.person);
            });
        }
        $scope.getdata = function(_url, _token, _person, _position) {
                mHttpGet.getdata(_url + 'p_token=' + _token + '&p_position_id=' + _position +
                        '&p_person_id=' + _person + "&p_date=" + $scope.startMon)
                    .then(function(data) {
                        $scope.LeaveData = data;
                        $scope.$emit('setLeave', $scope.LeaveData.legend);
                        $scope.LeaveDataShow.mon = $scope.LeaveData.mon;
                        $scope.LeaveDataShow.maxDay = $scope.LeaveData.maxDay;
                        $scope.LeaveDataShow.pers = [];
                        $scope.LeaveData.pers.forEach(function(value, key) {
                            $scope.moredata = true;
                            if (key <= 5) {
                                $scope.LeaveDataShow.pers.push(value);
                                $scope.partPosition = $scope.partPosition + 1;
                            }
                        });

                    }, function(data) {
                        //    console.log('обработка ошибки ' + data);
                    });
            }
            // наша ленивая подгрузка
        $scope.loadMore = function() {
            if ($scope.LeaveDataShow.pers.length > 4) {
                $scope.addpart();
                console.log('add part!!!!!!!')
            } else {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
            //  console.log("loadmore");
        }
        $scope.addpart = function() {
            var cnt = $scope.partPosition;
            $scope.LeaveData.pers.forEach(function(value, key) {
                $scope.moredata = true;
                if ((key > cnt - 1) && (key <= cnt + 5)) {
                    $scope.LeaveDataShow.pers.push(value);
                    $scope.partPosition = $scope.partPosition + 1;
                }
            });
            $scope.$broadcast('scroll.infiniteScrollComplete');
            if ($scope.partPosition >= $scope.LeaveData.pers.length) {
                $scope.moredata = false;
            }
        }
        $scope.getDay = function(d) {
                var dW = moment(d + '.' + $scope.LeaveData.mon, 'DD.MM.YYYY').isoWeekday();
                var tD = '';
                if (dW == 1) { tD = 'Пн'; }
                if (dW == 2) { tD = 'Вт'; }
                if (dW == 3) { tD = 'Ср'; }
                if (dW == 4) { tD = 'Чт'; }
                if (dW == 5) { tD = 'Пт'; }
                if (dW == 6) { tD = 'Сб'; }
                if (dW == 7) { tD = 'Вс'; }
                return tD;
            }
            // функция по диапозону
        Number.prototype.between = function(a, b) {
            var min = Math.min.apply(Math, [a, b]),
                max = Math.max.apply(Math, [a, b]);
            return this >= min && this <= max;
        };
        // last_day = function(_dt) {
        //         return (moment(_dt, 'DD.MM.YYYY').subtract(1, 'months').endOf('month'));
        //     }
        // функция по массиву
        Number.prototype.betweenArr = function(_pos) {
            var from;
            var to;
            var cr = moment(this + '.' + $scope.LeaveData.mon, 'DD.MM.YYYY');
            for (var i = 0; i < $scope.LeaveData.pers[_pos].period.length; i++) {
                if ($scope.LeaveData.pers[_pos].period[i].type != 'План1') {
                    from = moment($scope.LeaveData.pers[_pos].period[i].fromLeave, 'DD.MM.YYYY');
                    to = moment($scope.LeaveData.pers[_pos].period[i].toLeave, 'DD.MM.YYYY');

                    if (cr >= from && cr <= to) {
                        return $scope.LeaveData.pers[_pos].period[i].activecolor;
                        // return true; 
                    }
                }
            }
            return ''; // false;
        };
        $scope.hd = function() {
            $scope.showLegend = 'N';
        }
    };
})();