/**
 * Компонент отпуска подчиненных
 */
(function() {
    'use strict';
    angular
        .module('starter')
        .component('leavePlan', {
            templateUrl: 'components/leaveStaff/leavePlan.html',
            controller: leavePlanController,
            bindings: {
                url: '=', // url основного запроса
                token: '=',
                fndstr: '<', // строка для поиска
                person: '=', // person_id
                position: '=', // position_id
                findmode: '<'
            }
        });
    // url p_token=" + token + '&p_position_id=' + position +
    // '&p_person_id=' + person + "&p_date=" + $scope.startMon
    // инжекции в контроллер
    leavePlanController.inject = ['$rootScope', '$http'];

    /**
     * контроллер для компонента
     * @param {object} $scope
     * @param {element} $element
     * @param {object} $attrs
     * @param {object} $rootScope
     * @param {object} $http
     */
    function leavePlanController($scope, $element, $attrs, $rootScope, $http, MonthPicker, mHttpGet) {
        var ctrl = this;
        /**
         * Инициализация
         */
        ctrl.$onInit = function() {
            $scope.fndStr = ctrl.fndstr;
            $scope.find = { str: "", mode: "N" };
            moment.locale('ru');
            $scope.showLegend = 'Y';
            $scope.startYear = moment().format('YYYY');
            $scope.startMon = moment().format('DD.MM.YYYY');
            $scope.LeaveDataShow = {};
            $scope.LeaveDataShow.pers = [];
            $scope.partPosition = 0;
            $scope.LeaveData = {};
            MonthPicker.init({
                title: "Выберите месяц",
                cancelText: "Отмена",
                cancelClass: 'button-positive',
                monthLabels: ['Янв', 'Фев', 'Мар', 'Апр', 'Май', 'Июн', 'Июл', 'Авг', 'Сен', 'Окт', 'Ноя', 'Дек'],
                minMonthIndex: 0,
                maxMonthIndex: 11,
                minYear: new Date().getFullYear() - 1,
                maxYear: new Date().getFullYear() + 1,
                startingYear: new Date().getFullYear()
            });
            $scope.getdata(ctrl.url, ctrl.token, ctrl.person, ctrl.position, ctrl.person);
        };
        ctrl.$onChanges = function(changesObj) {
            console.log(changesObj);
            if (changesObj.findmode) {
                $scope.find.mode = changesObj.findmode.currentValue;
                if ($scope.find.mode == 'N') {
                    $scope.find.str = '';
                }
            }
            if (changesObj.fndstr) {
                if ($scope.find.mode == 'Y') {
                    $scope.find.str = changesObj.fndstr.currentValue;
                }
            }
        };
        /**
         * Уничтожение компонента
         */
        ctrl.$onDestroy = function() {}
        $scope.getdata = function(_url, _token, _person, _position) {
                mHttpGet.getdata(_url + 'p_token=' + _token + '&p_position_id=' + _position +
                        '&p_person_id=' + _person + "&p_date=" + $scope.startMon)
                    .then(function(data) {
                        $scope.LeaveData = data;
                        $scope.$emit('setLeaveP', $scope.LeaveData.legend);
                        $scope.LeaveDataShow.mon = $scope.LeaveData.mon;
                        $scope.LeaveDataShow.maxDay = $scope.LeaveData.maxDay;
                        $scope.LeaveDataShow.pers = [];
                        $scope.LeaveData.pers.forEach(function(value, key) {
                            $scope.moredata = true;
                            if (key <= 10) {
                                $scope.LeaveDataShow.pers.push(value);
                                $scope.partPosition = $scope.partPosition + 1;
                            }
                        });

                    }, function(data) {
                        //    console.log('обработка ошибки ' + data);
                    });
            }
            // наша ленивая подгрузка
        $scope.loadMore = function() {
            if ($scope.LeaveDataShow.pers.length > 4) {
                $scope.addpart();
                console.log('add part')
            } else {
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
            //  console.log("loadmore");
        }
        $scope.addpart = function() {
            var cnt = $scope.partPosition;
            $scope.LeaveData.pers.forEach(function(value, key) {
                $scope.moredata = true;
                if ((key > cnt - 1) && (key <= cnt + 5)) {
                    $scope.LeaveDataShow.pers.push(value);
                    $scope.partPosition = $scope.partPosition + 1;
                }
            });
            $scope.$broadcast('scroll.infiniteScrollComplete');
            if ($scope.partPosition >= $scope.LeaveData.pers.length) {
                $scope.moredata = false;
            }
        }
    };
})();