/**
 * Компонент нарушения трудовой подчиненных
 */
(function() {
    'use strict';
    angular
        .module('starter')
        .component('staffSkd', {
            templateUrl: 'components/skd/skdStaff.html',
            controller: staffSkdController,
            bindings: {
                url: '=', // url основного запроса
                token: '=',
                person: '=', // person_id
                dates: '=',
                position: '=',
                filters: '<'
            }
        });

    // инжекции в контроллер
    staffSkdController.inject = ['$rootScope', '$http'];

    /**
     * контроллер для компонента
     * @param {object} $scope
     * @param {element} $element
     * @param {object} $attrs
     * @param {object} $rootScope
     * @param {object} $http
     */
    function staffSkdController($scope, $http, $ionicLoading, $sce, mHttpGet, $rootScope, $state) {
        var ctrl = this;
        /**
         * Инициализация
         */
        ctrl.$onInit = function() {
            $scope.token = ctrl.token;
            $scope.person_id = ctrl.person;
            $scope.appStr2 = ctrl.url;
            $scope.countList = ctrl.dates;
            $scope.positionId = ctrl.position;
            $scope.find = ctrl.filters;
            $scope.countSelected = $scope.countList[0].id;
            $scope.startPeriod = $scope.countList[0].param2;
            $scope.loadData();
        };
        ctrl.$onChanges = function(changesObj) {
            // console.log(changesObj);
            $scope.find = changesObj.filters.currentValue;
        };
        /**
         * Уничтожение компонента
         */
        ctrl.$onDestroy = function() {}
        $scope.loadData = function() {
            $rootScope.skdMonthTs = $scope.startPeriod;
            showLoading('Загрузка');
            if ($scope.positionId != undefined) {
                mHttpGet.getdata($scope.appStr2 + ".show_list_skd_breach?p_position_id=" + $scope.positionId + "&p_period=" + $scope.startPeriod + "&p_token=" + $scope.token)
                    .then(function(data) {
                        $ionicLoading.hide();
                        console.log(data);
                        $scope.listBreach = data;
                    }),
                    function(data) {
                        console.log(status);
                        $ionicLoading.hide();
                    }
            }
        }
        $scope.filtrFio = function(fndName) {
            if (($scope.find == undefined) || ($scope.find == '')) {
                return true;
            }
            return ((fndName.fio.toUpperCase().indexOf($scope.find.toUpperCase()) !== -1) || (fndName.proff.toUpperCase().indexOf($scope.find.toUpperCase()) !== -1) || (fndName.org_n.toUpperCase().indexOf($scope.find.toUpperCase()) !== -1));
        };
        $scope.onchange = function(id) {
            if (id != undefined) {
                $rootScope.skdMonthNameTs = id.name;
                $scope.startPeriod = id.param2;
                $scope.loadData();
                console.log($scope.countSelected);
            }
        }
        $scope.goPersBreach = function(pers_id) {
            $rootScope.skdPersTs = pers_id;
            $state.go('app.skdPersonBreach');
        }
    };
})();