angular.module('starter.otifdata', [])

.controller('otifCtrl', function($scope, $ionicLoading, $timeout, mHttpGet, $ionicPopup, $ionicScrollDelegate, $ionicPopup, $http, opener) {
    $scope.labels = ["OTIF", ""];
    $scope.data = [0, 100];
    $scope.setColorBar('black');
    // $scope.cl = ["#1bc5bd", "#dcdcdc"];
    $scope.cl = [];
    $scope.donutColor = '';
    $scope.arrLegend1 = [];
    $scope.dataC1 = [];
    $scope.vMin = 0;
    $scope.vMax = 0;
    $scope.vLast = 0;
    $scope.vLastDt = '';
    // $scope.arrLegend1 = ['июл 2020', 'авг 2020', 'сен 2020', 56, 55, 40, 65, 80, 81, '', 55, 40];
    // $scope.dataC1 = [60, 80, 81, 56, 55, 40, 65, 85, 8, 56, 55, 40];
    $scope.dataClr = [];
    $scope.wnd = function(_url, n_f) {
        opener.wnd(_url, n_f, 'application/pdf');
    }
    $scope.getServDta = function() {
        mHttpGet.getdata($scope.appStr2 + ".list_org?p_top_org=1831&p_date=01.06.2018&p_person_id=" + $scope.person_id)
            .then(function(data) {
                $scope.BtnList = data;
                if ($scope.BtnList.otif) {
                    $scope.calcGraph($scope.BtnList.otif);
                }
            }, function(data) {
                console.log('обработка ошибки ' + data);
            });
    };
    $scope.getServDta();
    $scope.calcGraph = function(_arr) {
        $scope.arrLegend1 = [];
        $scope.dataC1 = [];
        for (i = 0; i, i < _arr.length; i++) {
            console.log(_arr[i]);
            if (i != _arr.length - 1) {
                $scope.arrLegend1.push(_arr[i].v_date);
                $scope.dataC1.push(_arr[i].v_cur);
            }
            $scope.vMin = _arr[i].v_min;
            $scope.vMax = _arr[i].v_max;
            $scope.vLast = _arr[i].v_cur;
            $scope.vLastDt = _arr[i].v_date;
            if ($scope.vLast <= $scope.vMin) {
                $scope.donutColor = '#f64e60d9';
            } else if (($scope.vLast > $scope.vMin) && ($scope.vLast < $scope.vMax)) {
                $scope.donutColor = '#ffa800d9';
            } else {
                $scope.donutColor = '#1bc5bdd9';
            }
        }
        // myChart.options.title.text = 'new title';
        myChart.data.labels = $scope.arrLegend1;
        myChart.data.datasets[0].data = $scope.dataC1;
        donutChart.data.datasets[0].data = [$scope.vLast, (100 - $scope.vLast)];
        donutChart.options.elements.center.text = $scope.vLast + '%';
        for (i = 0; i < $scope.dataC1.length; i++) {
            if ($scope.dataC1[i] <= $scope.vMin) {
                $scope.dataClr.push('#f64e60d9');
            } else if (($scope.dataC1[i] > $scope.vMin) && ($scope.dataC1[i] <= $scope.vMax)) {
                $scope.dataClr.push('#ffa800d9');
            } else {
                $scope.dataClr.push('#1bc5bdd9');
            }

        }
        $scope.cl = [$scope.donutColor, "#dcdcdc"];
        donutChart.data.datasets[0].backgroundColor = $scope.cl;
        donutChart.data.datasets[0].hoverBackgroundColor = $scope.cl;
        myChart.update();
        donutChart.update();
    }
    Chart.pluginService.register({
        beforeDraw: function(chart) {
            if (chart.config.options.elements.center) {
                // Get ctx from string
                var ctx = chart.chart.ctx;

                // Get options from the center object in options
                var centerConfig = chart.config.options.elements.center;
                var fontStyle = centerConfig.fontStyle || 'Arial';
                var txt = centerConfig.text;
                var color = centerConfig.color || '#000';
                var maxFontSize = centerConfig.maxFontSize || 75;
                var sidePadding = centerConfig.sidePadding || 20;
                var sidePaddingCalculated = (sidePadding / 100) * (chart.innerRadius * 2)
                    // Start with a base font of 30px
                ctx.font = "30px " + fontStyle;

                // Get the width of the string and also the width of the element minus 10 to give it 5px side padding
                var stringWidth = ctx.measureText(txt).width;
                var elementWidth = (chart.innerRadius * 2) - sidePaddingCalculated;

                // Find out how much the font can grow in width.
                var widthRatio = elementWidth / stringWidth;
                var newFontSize = Math.floor(30 * widthRatio);
                var elementHeight = (chart.innerRadius * 2);

                // Pick a new font size so it will not be larger than the height of label.
                var fontSizeToUse = Math.min(newFontSize, elementHeight, maxFontSize);
                var minFontSize = centerConfig.minFontSize;
                var lineHeight = centerConfig.lineHeight || 25;
                var wrapText = false;

                if (minFontSize === undefined) {
                    minFontSize = 20;
                }

                if (minFontSize && fontSizeToUse < minFontSize) {
                    fontSizeToUse = minFontSize;
                    wrapText = true;
                }

                // Set font settings to draw it correctly.
                ctx.textAlign = 'center';
                ctx.textBaseline = 'middle';
                var centerX = ((chart.chartArea.left + chart.chartArea.right) / 2);
                var centerY = ((chart.chartArea.top + chart.chartArea.bottom) / 2);
                ctx.font = fontSizeToUse + "px " + fontStyle;
                ctx.fillStyle = color;

                if (!wrapText) {
                    ctx.fillText(txt, centerX, centerY);
                    return;
                }

                var words = txt.split(' ');
                var line = '';
                var lines = [];

                // Break words up into multiple lines if necessary
                for (var n = 0; n < words.length; n++) {
                    var testLine = line + words[n] + ' ';
                    var metrics = ctx.measureText(testLine);
                    var testWidth = metrics.width;
                    if (testWidth > elementWidth && n > 0) {
                        lines.push(line);
                        line = words[n] + ' ';
                    } else {
                        line = testLine;
                    }
                }

                // Move the center up depending on line height and number of lines
                centerY -= (lines.length / 2) * lineHeight;

                for (var n = 0; n < lines.length; n++) {
                    ctx.fillText(lines[n], centerX, centerY);
                    centerY += lineHeight;
                }
                //Draw text in center
                ctx.fillText(line, centerX, centerY);
            }
        }
    });
    var ctx = document.getElementById("myChart2").getContext("2d");
    var myChart = new Chart(ctx, {
        type: 'bar',
        data: {
            labels: $scope.arrLegend1,
            datasets: [{
                label: 'Показатель OTIF',
                data: $scope.dataC1,
                backgroundColor: $scope.dataClr,
                borderWidth: 1
            }]
        },
        options: {
            title: {
                display: true,
                text: 'Дисциплина поставок OTIF фактический за год'
            },
            scales: {
                xAxes: [{
                    gridLines: {
                        display: false
                    },
                    ticks: {
                        beginAtZero: true,
                        maxRotation: 00,
                        minRotation: 0,
                        padding: 10,
                        autoSkip: true,
                        fontSize: 10
                    }
                }],
                yAxes: [{
                    ticks: {
                        beginAtZero: true
                    }
                }]
            },
            "animation": {
                // "duration": 1,
                "onComplete": function() {
                    var chartInstance = this.chart,
                        ctx = chartInstance.ctx;

                    ctx.font = Chart.helpers.fontString(Chart.defaults.global.defaultFontSize, Chart.defaults.global.defaultFontStyle, Chart.defaults.global.defaultFontFamily);
                    ctx.textAlign = 'center';
                    ctx.textBaseline = 'bottom';

                    this.data.datasets.forEach(function(dataset, i) {
                        var meta = chartInstance.controller.getDatasetMeta(i);
                        meta.data.forEach(function(bar, index) {
                            var data = dataset.data[index];
                            ctx.fillText(data, bar._model.x, bar._model.y - 5);
                        });
                    });
                }
            }
        }
    });
    // круглый
    var config = {
        type: 'doughnut',
        data: {
            labels: [
                "Выполнено",
                ""
            ],
            datasets: [{
                data: $scope.data,
                backgroundColor: $scope.cl, // цвета
                hoverBackgroundColor: $scope.cl // цвета при нажатии
            }]
        },
        options: {
            elements: {
                center: {
                    text: '',
                    color: '#6f6f74', // Default is #000000
                    fontStyle: '"-apple-system","Helvetica Neue",Roboto,"Segoe UI",sans-serif', // Default is Arial
                    sidePadding: 20, // Default is 20 (as a percentage)
                    minFontSize: 15, // Default is 20 (in px), set to false and text will not wrap.
                    lineHeight: 15 // Default is 25 (in px), used for when text wraps
                }
            }
        }
    };
    var donutCtx = document.getElementById("myChart3").getContext("2d");
    var donutChart = new Chart(donutCtx, config);
})