angular.module('starter.medReq', [])
    .factory('MedAction', function($q, mHttpGet, $ionicLoading, $http, mHttpPost, $ionicLoading) {
        return {
            getArgee: function(_url, _token) {
                var deferred = $q.defer();
                var xsrf = { 'URL': _url + '.patientagree_htp?p_token=' + _token, 'Type': 'GET' }
                $http({
                        method: 'POST',
                        url: 'https://galaxy.mmk.ru:443/api/Proxy',
                        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                        transformRequest: function(obj) {
                            var str = [];
                            for (var p in obj)
                                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                            return str.join("&");
                        },
                        data: xsrf
                    })
                    .success(function(data) {
                        deferred.resolve(data);
                        return deferred.promise;
                    })
                    .error(function(response) {
                        deferred.reject('Ошибка сервиса согласия на обработку данных');
                        return deferred.promise;
                    })
                return deferred.promise;
            },
            getPatient: function(_url, _token, _person) {
                var deferred = $q.defer();
                showLoading('Загрузка');
                var deferred = $q.defer();
                var xsrf = { 'URL': _url + '.patientIdenty_htp?p_token=' + _token + '&p_person_id=' + _person, 'Type': 'GET' }
                $http({
                        method: 'POST',
                        url: 'https://galaxy.mmk.ru:443/api/Proxy',
                        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                        transformRequest: function(obj) {
                            var str = [];
                            for (var p in obj)
                                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                            return str.join("&");
                        },
                        data: xsrf
                    })
                    .success(function(data) {
                        deferred.resolve(data);
                        return deferred.promise;
                    })
                    .error(function(response) {
                        deferred.reject('Ошибка сервиса согласия на обработку данных');
                        return deferred.promise;
                    })
                return deferred.promise;
            },
            getDoctor: function(_url, _token, _patient_id) {
                var deferred = $q.defer();
                showLoading('Загрузка');
                var deferred = $q.defer();
                var xsrf = { 'URL': _url + '.getSpecialists_htp?p_token=' + _token + '&p_patient_Id=' + _patient_id, 'Type': 'GET' }
                $http({
                        method: 'POST',
                        url: 'https://galaxy.mmk.ru:443/api/Proxy',
                        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                        transformRequest: function(obj) {
                            var str = [];
                            for (var p in obj)
                                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                            return str.join("&");
                        },
                        data: xsrf
                    })
                    .success(function(data) {
                        deferred.resolve(data);
                        return deferred.promise;
                    })
                    .error(function(response) {
                        deferred.reject('Ошибка сервиса согласия на обработку данных');
                        return deferred.promise;
                    })
                return deferred.promise;
            },
            getShedule: function(_url, _token, _patient_id, _week_num, _dept_id, _doc_id, _spec_id, _begin_day) {
                var deferred = $q.defer();
                showLoading('Загрузка');
                var deferred = $q.defer();
                var xsrf = {
                    'URL': _url + '.getSheduleWeek_htp?p_token=' + _token + '&p_patient_Id=' + _patient_id +
                        '&p_week_num=' + _week_num + '&p_dep_id=' + _dept_id + '&p_doc_id=' + _doc_id +
                        '&p_spec_id=' + _spec_id + '&p_begin_day=' + _begin_day,
                    'Type': 'GET'
                }
                $http({
                        method: 'POST',
                        url: 'https://galaxy.mmk.ru:443/api/Proxy',
                        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                        transformRequest: function(obj) {
                            var str = [];
                            for (var p in obj)
                                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                            return str.join("&");
                        },
                        data: xsrf
                    })
                    .success(function(data) {
                        deferred.resolve(data);
                        return deferred.promise;
                    })
                    .error(function(response) {
                        deferred.reject('Ошибка сервиса согласия на обработку данных');
                        return deferred.promise;
                    })
                return deferred.promise;
            },
            setShedule: function(_url, _token, _p_dep_id, _p_slot_id, _p_patient_id, _p_visit_date) {
                var deferred = $q.defer();
                showLoading('Загрузка');
                var deferred = $q.defer();
                var xsrf = {
                        'URL': _url + '.setSlot?p_token=' + _token + '&p_dep_id=' + _p_dep_id +
                            '&p_slot_id=' + _p_slot_id + '&p_patient_id=' + _p_patient_id + '&p_visit_date=' + _p_visit_date,
                        'Type': 'GET'
                    }
                    // var xsrf = {
                    //     'URL': _url + '.setSlot?p_token=100500' + _token + '&p_dep_id=100500' + _p_dep_id +
                    //         '&p_slot_id=100500' + _p_slot_id + '&p_patient_id=100500' + _p_patient_id + '&p_visit_date=100500' + _p_visit_date,
                    //     'Type': 'GET'
                    // }
                $http({
                        method: 'POST',
                        url: 'https://galaxy.mmk.ru:443/api/Proxy',
                        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                        transformRequest: function(obj) {
                            var str = [];
                            for (var p in obj)
                                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                            return str.join("&");
                        },
                        data: xsrf
                    })
                    .success(function(data) {
                        deferred.resolve(data);
                        return deferred.promise;
                    })
                    .error(function(response) {
                        deferred.reject('Ошибка сервиса подачи заявки');
                        return deferred.promise;
                    })
                return deferred.promise;
            },
            sendSMS: function(_url, _person_id, _date, _time, _doc_id, _doc_name, _doc_job, _token, _cab) {
                var deferred = $q.defer();
                // showLoading('Загрузка');
                setTimeout(function(v) { $ionicLoading.hide(); }, 200);
                var xsrf2 = {
                    p_person_id: _person_id,
                    p_date: _date,
                    p_time: _time,
                    p_doc_id: _doc_id,
                    p_doc_name: _doc_name,
                    p_doc_job: _doc_job,
                    p_token: _token,
                    p_cab: _cab
                };
                mHttpPost.getdata({ 'URL': _url + '.xxhr_doc_sms', 'Type': 'POST', 'Body': JSON.stringify(xsrf2) }).then(function(data) {
                    return deferred.resolve(data);
                }, function(data) {
                    $ionicLoading.hide();
                    deferred.reject('Ошибка сервиса отправки смс');
                });
                return deferred.promise;
            }
        }
    })
    .controller('medReqCtrl', function($scope, $ionicLoading, $timeout, mHttpGet, mHttpPost, $state, $rootScope, $ionicPopup, $q, MedAction, $ionicScrollDelegate, $ionicModal, mBookmark, cToast) {
        $rootScope.showDownMenu = 'N';
        $scope.step = 1;
        $scope.CDoctor = {};
        $scope.cntStepLoad = 0;
        $scope.currentDoc = {}; // здесь будет описание выбранного врача из сервисов мсч
        $scope.currentShedule = {}; // здесь будет описание выбранного графика из сервисов мсч
        $scope.shedule = {};
        $scope.topTitle = 'Специализация';
        mBookmark.saveData($scope.appStr2, 'app.newMedReq', 'Запись на прием к врачу', $scope.token, $scope.person_id);
        $scope.patientId = '';
        $scope.CDoctor.docId = null;
        $scope.CDoctor.deptId = null;
        $scope.CDoctor.weekNum = null;
        $scope.CDoctor.specId = null;
        $scope.CDoctor.beginDay = null;
        $scope.CDoctor.slotId = null;
        $scope.CDoctor.ed = null;
        $scope.footerIsHidden = true;
        $scope.errorText = null; // текс ошибки от мсч
        $scope.dataMed = [];
        $scope.emptyData = [];
        $scope.specArr = []; // массив специальностей
        $scope.emptyArr = []; // массив специальностей без талонов (серые)
        $scope.shedArr = []; // преобразованный массив слотов для посещения
        $scope.docArr = [];
        $scope.setColorBar('black');
        $ionicLoading.hide();
        // console.log(moment('23.09.2019', 'DD.MM.YYYY').add(1, 'd').format('DD-MM-YYYY'));
        showLoading('Загрузка');
        MedAction.getArgee($scope.appStr_med_neptun, $scope.token).then(
            function(val) {
                console.log('Нам дали данные!!!!!!');
                console.log(val);
                showLoading('Загрузка');
                MedAction.getPatient($scope.appStr_med_neptun, $scope.token, $scope.person_id).then(
                    function(valP) {
                        showLoading('Загрузка');
                        console.log('Нам дали данные пациента!!!!!!');
                        console.log(valP);
                        $scope.patientId = valP.patientId;
                        if ($scope.patientId != null) { // если определился пациент ид
                            MedAction.getDoctor($scope.appStr_med_neptun, $scope.token, $scope.patientId).then(
                                function(valD) {
                                    $scope.CDoctor.weekNum = valD.weekNumber;
                                    $scope.begin_week_etalon = angular.copy(valD.weekNumber);
                                    $scope.CDoctor.beginDay = valD.bd;
                                    // console.log('Нам дали данные доктора!!!!!!');
                                    // console.log(valD);
                                    try {
                                        $scope.dataMed = valD.rows.sort(function(a, b) {
                                            if (a.specialName < b.specialName) { return -1; }
                                            if (a.specialName > b.specialName) { return 1; }
                                            // if (a.tickets < b.tickets) { return 1; }
                                            // if (a.tickets > b.tickets) { return -1; }
                                            return 0;
                                        }).filter(function(f) { return f.tickets != 0 });
                                    } catch (err) {
                                        $ionicLoading.hide();
                                        cToast.show('Ошибка получения данных от МСЧ');
                                        // try {
                                        //     $c_ordovaToast.showShortBottom('Ошибка получения данных от МСЧ').then(function(success) {}, function(error) {
                                        //         // error
                                        //     });
                                        // } catch (err) {}
                                    }
                                    // массив с пустыми врачами
                                    try {
                                        if (!valD.errorText) {
                                            $scope.emptyData = valD.rows.sort(function(a, b) {
                                                if (a.specialName < b.specialName) { return -1; }
                                                if (a.specialName > b.specialName) { return 1; }
                                                return 0;
                                            }).filter(function(f) { return f.tickets == 0 });
                                        } else {
                                            $scope.errorText = valD.errorText;
                                            cToast.show(valD.errorText);
                                            // try {
                                            //     $c_ordovaToast.showShortBottom(valD.errorText).then(function(success) {}, function(error) {});
                                            // } catch (err) {}
                                        }
                                    } catch (err) {
                                        $ionicLoading.hide();
                                        cToast.show('Ошибка получения данных от МСЧ');
                                        // try {
                                        //     $c_ordovaToast.showShortBottom('Ошибка получения данных от МСЧ').then(function(success) {}, function(error) {
                                        //         // error
                                        //     });
                                        // } catch (err) {};
                                    }
                                    var tmp = -1;
                                    $scope.dataMed.forEach(function(fe) {
                                        tmp = -1;
                                        try {
                                            tmp = $scope.specArr.findIndex(function(fi) { return fi.specialName === fe.specialName });
                                        } catch (err) {
                                            for (var i = 0; i < $scope.specArr.length; ++i) {
                                                if ($scope.specArr[i].specialName === fe.specialName) {
                                                    tmp = i;
                                                    break;
                                                }
                                            }
                                        }
                                        // console.log(tmp);
                                        if (tmp === -1) {
                                            $scope.specArr.push({ specialName: fe.specialName, specialId: fe.specialId, cnt: 1, tickets: fe.tickets });
                                        } else {
                                            $scope.specArr[tmp].cnt = $scope.specArr[tmp].cnt + 1;
                                            $scope.specArr[tmp].tickets = $scope.specArr[tmp].tickets + $scope.specArr[tmp].tickets;
                                        }
                                    });
                                    tmp = -1;

                                    $scope.emptyData.forEach(function(fe) {
                                        tmp = -1;
                                        try {
                                            tmp = $scope.emptyArr.findIndex(function(fi) { return fi.specialName === fe.specialName });
                                        } catch (err) {
                                            for (var i = 0; i < $scope.emptyArr.length; ++i) {
                                                if ($scope.emptyArr[i].specialName === fe.specialName) {
                                                    tmp = i;
                                                    break;
                                                }
                                            }
                                        }
                                        // console.log(tmp);
                                        if (tmp === -1) {
                                            $scope.emptyArr.push({ specialName: fe.specialName, specialId: fe.specialId, cnt: 1, tickets: fe.tickets });
                                        } else {
                                            $scope.emptyArr[tmp].cnt = $scope.emptyArr[tmp].cnt + 1;
                                            $scope.emptyArr[tmp].tickets = $scope.emptyArr[tmp].tickets + $scope.emptyArr[tmp].tickets;
                                        }
                                    });
                                    // console.log($scope.specArr);
                                    $ionicLoading.hide();
                                },
                                function(errP) {
                                    console.log(errP);
                                    $ionicLoading.hide();
                                }
                            );
                        } else {
                            $scope.errorText = valP.errorText;
                            $ionicLoading.hide();
                        }
                    },
                    function(errP) {
                        console.log(errP);
                        $ionicLoading.hide();
                    }
                );
            },
            function(err) {
                console.log(err);
                $ionicLoading.hide();
            }
        );
        $scope.setSpecId = function(_id, _tickets) {
            if (_tickets !== 0) {
                $scope.docArr = angular.copy($scope.dataMed.filter(function(f) { return f.specialId == _id; }));
                $scope.footerIsHidden = false;
                $scope.topTitle = $scope.docArr[0].specialName;
                // console.log($scope.docArr);
            }
        }
        $scope.setDocId = function(_id) {
            $scope.CDoctor.docId = _id;
            $scope.goStep(1);
        }
        $scope.backToSpecId = function(_id) {
            $scope.topTitle = 'Специализация';
            $scope.footerIsHidden = true;
            $scope.docArr = [];
        }
        $scope.getShedule = function(_currentDoc) {
                var ed;
                showLoading('Загрузка');
                $scope.cntStepLoad = 0;
                var tmp;
                MedAction.getShedule($scope.appStr_med_neptun, $scope.token, $scope.patientId, $scope.CDoctor.weekNum, _currentDoc.depId, $scope.CDoctor.docId, _currentDoc.specialId, $scope.CDoctor.beginDay).then(
                    function(valS) {
                        console.log('Нам дали расписание!!!!!!');
                        ed = moment(valS.ed, 'DD.MM.YYYY').clone().add(1, 'days').format('DD.MM.YYYY');
                        $scope.CDoctor.ed = ed; //valS.ed;
                        $scope.CDoctor.weekNum = valS.nextWeek;
                        // $scope.CDoctor.weekNum = String(Number.parseInt(valS.currentWeek) + 1);
                        $scope.tmpDoc = valS;
                        // console.log(valS);
                        $scope.shedule = valS;
                        $scope.customShedule();
                        if (valS.rows) {
                            $scope.shedule.rows = valS.rows.filter(function(f) { return (f.avail != 0) && (f.free == 1); });
                            if ($scope.shedule.rows) {
                                if ($scope.shedule.rows.length === 0) {
                                    $scope.moredata = false;
                                    $scope.loadMore(); // ничего не нашли но пробуем смотреть на следующую неделю 
                                    return;
                                } else {
                                    $scope.moredata = true;
                                    $ionicLoading.hide();
                                    return;
                                }
                                if ($scope.shedule.rows.length < 2) {
                                    $scope.loadMore();
                                    return;
                                }
                            } // else if(valS.rows) { 
                            //    $scope.shedule =valS.rows; $scope.loadMore(); 
                            // }
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                            // $ionicLoading.hide();
                        } else { $ionicLoading.hide(); }
                    },
                    function(errP) {
                        console.log(errP);
                        $ionicLoading.hide();
                    }
                );
            }
            //  функция преобразования массива данных со слотами для посещения
        $scope.customShedule = function() {
            $scope.shedArr = [];
            var tmp = -1;
            $scope.shedule.rows.forEach(function(fe) {
                try {
                    tmp = $scope.shedArr.findIndex(function(fi) { return fi.data === fe.visitDate; });
                } catch (err) {
                    for (var i = 0; i < $scope.shedArr.length; ++i) {
                        if ($scope.shedArr[i].data == fe.visitDate) {
                            tmp = i;
                            break;
                        }
                    }
                }
                if (tmp === -1) {
                    if ((fe.avail != 0) && (fe.free == 1)) {
                        var d;
                        if (fe.dayName === 'Пн') { d = 'Понедельник'; }
                        if (fe.dayName === 'Вт') { d = 'Вторник'; }
                        if (fe.dayName === 'Ср') { d = 'Среда'; }
                        if (fe.dayName === 'Чт') { d = 'Четверг'; }
                        if (fe.dayName === 'Пт') { d = 'Пятница'; }
                        if (fe.dayName === 'Сб') { d = 'Суббота'; }
                        if (fe.dayName === 'Вс') { d = 'Воскресенье'; }
                        $scope.shedArr.push({ data: fe.visitDate, dw: d, rows: [fe] });
                    }
                } else {
                    if ((fe.avail != 0) && (fe.free == 1)) {
                        $scope.shedArr[tmp].rows.push(fe);
                    }
                }
            });
            // console.log($scope.shedArr);
        }
        $scope.goStep = function(_vCurrent) {
            if (_vCurrent === 0) {
                $scope.topTitle = $scope.docArr[0].specialName;
                $ionicScrollDelegate.scrollTop();
                $scope.step = 1;
                $scope.shedArr = [];
                $scope.CDoctor.docId = null;
                $scope.CDoctor.slotId = null;
                $scope.CDoctor.deptId = null;
                $scope.shedule = {};
                $scope.moredata = false;
                $scope.CDoctor.weekNum = angular.copy($scope.begin_week_etalon);
            }
            if (_vCurrent === 1) {
                $scope.topTitle = 'Врач';
                $ionicScrollDelegate.scrollTop();
                $scope.CDoctor.slotId = null;
                $scope.CDoctor.hour = null;
                $scope.CDoctor.weekNum = angular.copy($scope.begin_week_etalon);
                if ($scope.CDoctor.docId === null) {
                    console.log('Не выбран врач');
                } else {
                    try {
                        console.warn($scope.dataMed.find(function(fnd) { return fnd.docId == $scope.CDoctor.docId; }));
                        $scope.currentDoc = $scope.dataMed.find(function(fnd) { return fnd.docId == $scope.CDoctor.docId; });
                        if (!$scope.shedule.ed) {
                            $scope.getShedule($scope.dataMed.find(function(fnd) { return fnd.docId == $scope.CDoctor.docId; }));
                        }
                        $scope.step = 2;
                    } catch (err) {
                        $scope.currentDoc = $scope.dataMed.filter(function(fnd) {
                            return fnd.docId == $scope.CDoctor.docId;
                        })[0];
                        if (!$scope.shedule.ed) {
                            $scope.getShedule($scope.dataMed.filter(function(fnd) {
                                return fnd.docId == $scope.CDoctor.docId;
                            })[0]);
                        }
                        $scope.step = 2;
                    }
                }
            }
            if (_vCurrent === 2) {
                $scope.topTitle = 'Подтверждение записи';
                $scope.moredata = false;
                $ionicScrollDelegate.scrollTop();
                // $ionicScrollDelegate.scrollBottom();
                if ($scope.CDoctor.slotId === null) {
                    console.log('Не выбран день недели');
                } else {
                    // $scope.getHour();
                    try {
                        $scope.currentShedule = $scope.shedule.rows.find(function(fnd) { return fnd.slotId == $scope.CDoctor.slotId; });
                    } catch (err) {
                        $scope.currentShedule = $scope.shedule.rows.filter(function(fnd) {
                            return fnd.slotId == $scope.CDoctor.slotId;
                        })[0]
                    }
                    console.log($scope.currentShedule);
                    $scope.step = 3;
                }
            }
        }
        $scope.loadMore = function() {
            // if ($scope.shedule.rows.length != 0) {
            var ed;
            // $scope.cntStepLoad = $scope.cntStepLoad + 1;
            // $scope.CDoctor.weekNum = String(Number($scope.CDoctor.weekNum) + 1);
            // $scope.CDoctor.ed = moment($scope.CDoctor.ed, 'DD.MM.YYYY').clone().add(1, 'days').format('DD.MM.YYYY');
            MedAction.getShedule($scope.appStr_med_neptun, $scope.token, $scope.patientId, $scope.CDoctor.weekNum, $scope.currentDoc.depId, $scope.CDoctor.docId, $scope.currentDoc.specialId, $scope.CDoctor.ed).then(
                function(valS) {
                    $scope.cntStepLoad = $scope.cntStepLoad + 1;
                    $scope.CDoctor.weekNum = valS.nextWeek; // String(Number($scope.CDoctor.weekNum) + 1);
                    // $scope.CDoctor.weekNum = String(Number.parseInt($scope.CDoctor.weekNum) + 1);
                    const ed = moment(valS.ed, 'DD.MM.YYYY').clone().add(1, 'days').format('DD.MM.YYYY');
                    $scope.CDoctor.ed = ed; // valS.ed;
                    console.log('Пошла порция');
                    // console.log(ed);
                    // console.log(valS);
                    try {
                        const tmp_shed = valS.rows.filter(function(f) { return (f.avail != 0) && (f.free == 1); });
                        tmp_shed.forEach(function(value) {
                            try {
                                if ($scope.shedule.rows.findIndex(function(f) { return (f.slotId == value.slotId); }) == -1) {
                                    $scope.shedule.rows.push(value);
                                }
                            } catch (err) {
                                var tmpIndx = -1;
                                for (var i = 0; i < $scope.shedule.length; ++i) {
                                    if ($scope.shedule[i].slotId == value.slotId) {
                                        tmpIndx = i;
                                        break;
                                    }
                                }
                                if (tmpIndx == -1) {
                                    $scope.shedule.rows.push(value);
                                }
                            }
                        });
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        if ($scope.shedule.rows.length === 0) {
                            // $scope.CDoctor.ed = valS.ed;
                            if ($scope.cntStepLoad < 3) {
                                $scope.loadMore();
                            } else { $ionicLoading.hide(); }
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                            $scope.moredata = false;
                        } else {
                            $scope.moredata = true;
                            $ionicLoading.hide();
                        }
                        $scope.customShedule();
                    } catch (err) {
                        console.warn(err);
                        $ionicLoading.hide();
                    }
                },
                function(errP) {
                    console.log(errP);
                    // console.log(valS);
                    $ionicLoading.hide();
                }
            );
            // }
            // else {
            //     $scope.$broadcast('scroll.infiniteScrollComplete');
            // }
        }
        $scope.showAlert = function(_strCab) {
            var alertPopup = $ionicPopup.alert({
                title: 'Вы записаны',
                template: '<div class="bgFinishDocBlack" style="padding: 10px;"><p>Врач</p>' +
                    '<p class="docFinishName">' + $scope.shedule.docName + '</p>' +
                    '<p class="bgProff">' + $scope.shedule.specialName + '</p>' +
                    '<div class="finishLine"><div style="display: inline; "><house-bld-icon-black></house-bld-icon-black></div>' +
                    '<div class="finishAdress" style="display: inline; padding-left: 10px;">' /*+ $scope.shedule.postAddress + ', '*/ +
                    $scope.shedule.depName + _strCab + '</div></div></div>' +
                    // блок времени
                    '<div class="finishDateBg"><div style="position: absolute; top: 20px;"><div><red-flag-h></red-flag-h></div></div>' +
                    '<div class="finishDateText" style="padding-left: 35px;"><p>' + $scope.currentShedule.visitDate + '</p>' +
                    '<p><svg width="20" height="20" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg">' +
                    '<path d="M10 0C4.5 0 0 4.5 0 10C0 15.5 4.5 20 10 20C15.5 20 20 15.5 20 10C20 4.5 15.5 0 10 0ZM14.2 14.2L9 ' + '11V5H10.5V10.2L15 12.9L14.2 14.2Z" fill="white"></path>' +
                    '</svg> <span style="padding-right: 10px">' + $scope.currentShedule.slotTime + '</span>' +
                    '</p></div></div>' +
                    '<ion-item class="item item-text-wrap bgMedGray">' +
                    // старое оформление попапа
                    '<div style="    text-align: center;"> <mail-icon></mail-icon><br> Сообщение о бронировании было отправлено по СМС </div>',
                cssClass: 'greenpopup'
            });
            alertPopup.then(function(res) {
                console.log('Здесь можно сделать действие назад или бросить пользователя к списку поданных заявок');
                $scope.Back();
            });
        };
        $scope.finish = function() {
            try {
                console.table({
                    slotId: $scope.currentShedule.slotId,
                    visDate: $scope.currentShedule.visitDate,
                    p_dep_id: $scope.currentDoc.depId,
                    p_patient_id: $scope.patientId
                });
            } catch (err) {
                console.log({
                    slotId: $scope.currentShedule.slotId,
                    visDate: $scope.currentShedule.visitDate,
                    p_dep_id: $scope.currentDoc.depId,
                    p_patient_id: $scope.patientId
                });
            }
            var val = {
                "success": false,
                "errorText": 'Нет мест ушла за пивом'
            };
            var strCab = '';
            // if (($scope.currentShedule.CabNumber != '') && ($scope.currentShedule.CabNumber)) {
            //     strCab = 
            //         '<span>' +
            //         ', каб. ' + $scope.currentShedule.CabNumber +
            //         '</span>' 
            // }
            // $scope.showAlert(strCab);
            MedAction.setShedule($scope.appStr_med_neptun, $scope.token, $scope.currentDoc.depId, $scope.currentShedule.slotId, $scope.patientId, $scope.currentShedule.visitDate).then(
                function(val) {
                    $ionicLoading.hide();
                    // $scope.Back();
                    // $scope.showModalOk();
                    if (val.success) {
                        MedAction.sendSMS($scope.appStr_med_neptun, $scope.person_id, $scope.currentShedule.visitDate, $scope.currentShedule.slotTime, $scope.CDoctor.docId, $scope.shedule.docName, $scope.shedule.specialName, $scope.token, $scope.currentShedule.CabNumber).then(
                            function(val) {
                                console.log(val);
                                $ionicLoading.hide();
                            },
                            function(err) {
                                console.log(err);
                                $ionicLoading.hide();
                            });
                        $scope.Back();
                        $scope.showModalOk();
                    } else {
                        $ionicLoading.hide();
                        var alertPopupNo = $ionicPopup.alert({
                            title: 'Ошибка записи',
                            template: '<ion-item class="item item-text-wrap bgMedGray">' +
                                '<p class="textMedBlack">' +
                                'Причина: <span class="numRed"> &nbsp;' + val.errorText + '</span>' +
                                '</p>' +
                                '</ion-item>',
                            cssClass: 'redpopup'
                        });
                        alertPopupNo.then(function(res) {
                            console.log('Здесь можно сделать действие назад или бросить пользователя к списку поданных заявок');
                            $scope.goStep(0);
                        });
                    }
                },
                function(err) {
                    console.log(err);
                    $ionicLoading.hide();
                }
            );
        }
    });