angular.module('starter.prize90', [])
    .directive('a', function() {
        return {
            restrict: 'E',
            link: function(scope, element, attrs) {
                if (!attrs.href) {
                    return;
                }
                var externalRe = new RegExp("^(http|https)://");
                var url = attrs.href;

                if (externalRe.test(url)) {
                    element.on('click', function(e) {
                        e.preventDefault();
                        if (attrs.ngClick) {
                            scope.$eval(attrs.ngClick);
                        }
                        // window.open(encodeURI(url), '_system');
                    });
                }
            }
        };
    })
    .controller('prize90Ctrl', function($scope, $http, $ionicLoading, $sce, MsgHtmlFactory, $rootScope, $ionicPopup, $stateParams, mHttpGet, mHttpPost, cToast) {
        $scope.setColorBar('black');
        $scope.listMsgArr = [];
        $scope.txt = {};
        $scope.txt.tcomment = "";
        $scope.getC = function() {
            mHttpGet.getdata($scope.appStr3 + ".get_congratulations_90?p_person_id=" + $scope.person_id + "&p_token=" + $scope.token)
                .then(function(data) {
                    $scope.listMsgArr = data;
                    $scope.l1 = data.length; //берём длину массива для показа/скрытия шапки
                    for (i = 0; i < $scope.listMsgArr.length; i++) {
                        $scope.listMsgArr[i].msgHtml = $sce.trustAsHtml($scope.listMsgArr[i].vtext);
                    }
                }, function(data) {
                    //    console.log('обработка ошибки ' + data);
                });
        };
        $scope.getC();
        $scope.sendC = function() {
            showLoading('Загрузка');
            var xsrf = { c_text: $scope.txt.tcomment, p_person_id: $scope.person_id, p_token: $scope.token };
            $http({
                    method: 'POST',
                    url: $scope.appStr3 + '.send_congratulations_90',
                    headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                    transformRequest: function(obj) {
                        var str = [];
                        for (var p in obj)
                            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                        return str.join("&");
                    },
                    data: xsrf
                }).success(function(response) {
                    console.log(response);
                    $ionicLoading.hide();
                    if (response) {
                        if (response.res == 'Y') {
                            cToast.show(response.msg);
                            $scope.getC();
                        } else {
                            cToast.show(response.msg);
                        }
                    }
                })
                .error(function(data, status, headers, config) {
                    console.log(status);
                    $ionicLoading.hide();
                    $scope.getC();
                })

        };
        // $scope.listMsgArr = [
        //     { "vname": "ММК", "vtext": "Позравляем! Вы стали участником новогоднего розыгрыша", "id": "54721", "class": "chat-bubble left", "fio": "ММК", "msg_type": "back" },
        //     { "vname": "ММК", "vtext": "Ваш номер: 245", "id": "54721", "class": "chat-bubble left", "fio": "ММК", "msg_type": "back" },
        //     { "vname": "Иванов, Иван Иванович", "vtext": "Текст позравления работника", "id": "54721", "class": "chat-bubble right", "fio": "Иванов, Иван Иванович . Производство металла с покрытием", "msg_type": "feed" }
        // ]
        // for (i = 0; i < $scope.listMsgArr.length; i++) {
        //     $scope.listMsgArr[i].msgHtml = $sce.trustAsHtml($scope.listMsgArr[i].vtext);
        // }
    })