angular.module('starter.queSiz', [])
    .factory('queueAction', function($q, mHttpGet, $ionicLoading, $http, mHttpPost, $ionicLoading) {
        return {
            getServList: function(_url) {
                var deferred = $q.defer();
                var xsrf = { 'URL': 'http://161.8.25.99/pz2/apiv2/serviceslist/', 'Type': 'GET' }
                $http({
                        method: 'POST',
                        url: 'https://galaxy.mmk.ru:443/api/Proxy',
                        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                        transformRequest: function(obj) {
                            var str = [];
                            for (var p in obj)
                                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                            return str.join("&");
                        },
                        data: xsrf
                    })
                    .success(function(data) {
                        deferred.resolve(data);
                        return deferred.promise;
                    })
                    .error(function(response) {
                        deferred.reject('Ошибка получения сервисов электронной очереди');
                        return deferred.promise;
                    })
                return deferred.promise;
            },
            getServInfo: function(_id) {
                var deferred = $q.defer();
                showLoading('Загрузка');
                var deferred = $q.defer();
                var xsrf = { 'URL': 'http://161.8.25.99/pz2/apiv2/getserviceinfo/' + _id + '/', 'Type': 'GET' }
                $http({
                        method: 'POST',
                        url: 'https://galaxy.mmk.ru:443/api/Proxy',
                        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                        transformRequest: function(obj) {
                            var str = [];
                            for (var p in obj)
                                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                            return str.join("&");
                        },
                        data: xsrf
                    })
                    .success(function(data) {
                        deferred.resolve(data);
                        return deferred.promise;
                    })
                    .error(function(response) {
                        deferred.reject('Ошибка получения данных по времени записи электронной очереди');
                        return deferred.promise;
                    })
                return deferred.promise;
            },
            setTime: function(_date, _service, _time) {
                var deferred = $q.defer();
                // showLoading('Загрузка');
                setTimeout(function(v) { $ionicLoading.hide(); }, 200);
                var xsrf2 = {
                    date: _date,
                    service: _service,
                    time: _time
                };
                mHttpPost.getdata({ 'URL': 'http://161.8.25.99/pz2/apiv2/regnewticket/', 'Type': 'POST', 'Body': JSON.stringify(xsrf2) }).then(function(data) {
                    return deferred.resolve(data);
                }, function(data) {
                    $ionicLoading.hide();
                    deferred.reject('Ошибка сервиса регистрации талона');
                });
                return deferred.promise;
            }
        }
    })
    .controller('queSizCtrl', function($scope, $ionicLoading, $timeout, mHttpGet, $state, $rootScope, queueAction, $ionicPopup, $ionicScrollDelegate, mHttpPost, mBookmark) {
        $scope.servList = {}; // список сервисов
        $scope.step = 0;
        $scope.servListInfo = {}; // список информации о сервисе - временные слоты
        $scope.id = '';
        $scope.ServiceName = '';
        $scope.date = '';
        $scope.timeUser = '';
        $scope.numT = ''; // номер талона
        $rootScope.showDownMenu = 'N';
        $scope.passT = ''; // пароль талона
        mBookmark.saveData($scope.appStr2, 'app.queueSiz', 'Электронная очередь на получение СИЗ', $scope.token, $scope.person_id);
        $scope.setColorBar('black');
        $scope.getServList = function(_url) {
            var ed;
            showLoading('Загрузка');
            queueAction.getServList(_url).then(
                function(valS) {
                    $scope.step = 1;
                    console.log('Нам дали список услуг!!!!!!');
                    console.log(valS);
                    $scope.servList = valS;
                    if ($scope.servList.status != 1) {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Ошибка получения данных',
                            content: $scope.servList.note
                        });
                        $scope.Back();
                    }
                    $ionicLoading.hide();
                },
                function(errP) {
                    console.log(errP);
                    $ionicLoading.hide();
                }
            );
        }
        $scope.getServInfo = function(_id) {
            var ed;
            showLoading('Загрузка');
            queueAction.getServInfo(_id).then(
                function(valS) {
                    console.log('Нам дали список сервисов!!!!!!');
                    console.log(valS);
                    $scope.servListInfo = valS;
                    if ($scope.servListInfo.status != 1) {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Ошибка получения данных',
                            content: $scope.servListInfo.note
                        });
                        $scope.Back();
                    }
                    $ionicLoading.hide();
                },
                function(errP) {
                    console.log(errP);
                    $ionicLoading.hide();
                }
            );
        }
        $scope.setTimeServer = function(_date, _service, _time) {
            var ed;
            showLoading('Загрузка');
            queueAction.setTime(_date, _service, _time).then(
                function(valS) {
                    console.log('Мы зарегистрировались!!!!!!');
                    console.log(valS);
                    if (valS.status != 1) {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Ошибка получения данных',
                            content: valS.note
                        });
                        $scope.Back();
                    } else {
                        $scope.step = 2;
                        $scope.numT = valS.data.ticket; // номер талона
                        $scope.passT = valS.data.number; // пароль талона
                        $ionicScrollDelegate.scrollTop();
                        // ответ ок теперь кинем смс
                        var xsrf = {
                            Body: '{"p_person_id":"' + $scope.person_id + '", ' +
                                '"p_token": "' + $scope.token + '", "p_text1": "' + _date + '", ' +
                                '"p_text2": "' + _time + '", "p_text3": "' + valS.data.number + '", "p_text4": "' + valS.data.ticket + '"} ',
                            URL: $scope.appStr_sms + '.semd_msg_siz_q',
                            Type: 'POST'
                        };
                        mHttpPost.getdata(xsrf)
                            .then(function(data) {
                                console.log('send_sms');
                            }, function(data) {
                                $ionicLoading.hide();
                                $scope.listMsg();
                            });
                        $ionicLoading.hide();
                    }
                },
                function(errP) {
                    console.log(errP);
                    $ionicLoading.hide();
                }
            );
        }
        mHttpGet.getdata($scope.appStr + ".get_request_access?p_token=" + $scope.token + "&p_person_id=" + $scope.person_id + "&p_asg_id=" + $scope.assignment_id + "&p_type=" + 'SIZ_QUE')
            .then(function(data) {
                $scope.result = data;
                if ($scope.result[0].access == 'N') {
                    $ionicPopup.alert({
                        title: 'Подача заявки невозможна',
                        content: $scope.result[0].msg
                    }).then(function(res) {
                        $scope.Back();
                    });
                } else {
                    $scope.getServList('1');
                }
            }, function(data) {
                //    console.log('обработка ошибки ' + data);
            });
        $scope.toggleGroup = function(group) {
            if ($scope.isGroupShown(group)) {
                $scope.shownGroup = null;
            } else {
                $scope.shownGroup = group;
                $scope.date = group.dt;
                $scope.timeUser = '';
            }
        };
        $scope.setActiveServ = function(_serv) {
            if ($scope.isActiveShown(_serv)) {
                $scope.shownActive = null;
            } else {
                $scope.shownActive = _serv;
                $scope.id = _serv.id;
                $scope.ServiceName = _serv.ServiceName;
                $scope.date = '';
                $scope.timeUser = '';
                $scope.getServInfo(_serv.id);
            }
        }
        $scope.setPreTime = function(_time) {
            $scope.timeUser = _time;
            $ionicScrollDelegate.scrollBottom();
        }
        $scope.setTime = function() {
            console.log($scope.id);
            console.log($scope.date);
            console.log($scope.timeUser);
            $scope.setTimeServer($scope.date, $scope.id, $scope.timeUser);
        }
        $scope.isActiveShown = function(_serv) {
            return $scope.shownActive === _serv;
        };
        $scope.isGroupShown = function(group) {
            return $scope.shownGroup === group;
        };
    });