angular.module('starter.restartPc', [])
    .controller('restartPcCtrl', function($scope, $ionicLoading, $timeout, $http, $ionicHistory, $rootScope, $ionicNavBarDelegate, cToast, $ionicPopup, mHttpGet) {
        $scope.isLoad = true;
        $scope.isLoadInfo = true;
        $scope.rebotArr = [];
        $scope.items = [];
        $scope.setPc = function(_serv, _i) {
            if ($scope.items[_i].active) {
                if ($scope.items[_i].active == 'Y') {
                    $scope.items[_i].active = 'N';
                } else { $scope.items[_i].active = 'Y'; }
            } else {
                $scope.items[_i].active = 'Y';
            }
        }
        $scope.setColorBar('black');
        $scope.init = function() {
            mHttpGet.getdata($scope.appStr3 + ".get_status_reboot_list?p_person_id=" + $scope.person_id + "&p_token=" + $scope.token, false)
                .then(function(data) {
                    $scope.rebootInfo = data;
                    $scope.isLoadInfo = false;
                }),
                function(data) {
                    $scope.isLoadInfo = false;
                };
            var xsrf = {
                'URL': 'http://idm.hq.corp.mmk.chel.su/ords/xxrms/export/resetPcRequests?EMPL_NUMBER=' + $scope.v_emp_num,
                'Type': 'GET'
            }
            $http({
                    method: 'POST',
                    url: 'https://galaxy.mmk.ru:443/api/Proxy',
                    headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                    transformRequest: function(obj) {
                        var str = [];
                        for (var p in obj)
                            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                        return str.join("&");
                    },
                    data: xsrf
                })
                .success(function(data) {
                    console.log(data);
                    $scope.items = data.items;
                    $scope.isLoad = false;
                })
                .error(function(response) {
                    $scope.isLoad = false;
                    cToast.show('Ошибка сервиса согласия на обработку данных');
                    console.log('Ошибка сервиса согласия на обработку данных');
                });
        }
        $scope.init();
        $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
            viewData.enableBack = true;
        });

        $scope.toMain = function() {
            $scope.goHome('app.main');
        }
        $scope.startReboot = function() {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Подтвердите заявку',
                template: 'Вы хотите выполнить перезагрузку отмеченных компьютеров?',
                buttons: [
                    { text: 'Нет' },
                    {
                        text: '<b>Перезагрузить</b>',
                        type: 'button-positive',
                        onTap: function(e) {
                            $scope.rebotArr = [];
                            for (i = 0; i < $scope.items.length; i++) {
                                if ($scope.items[i].active == 'Y') {
                                    $scope.rebotArr.push($scope.items[i]);
                                }
                            }
                            $scope.rbtToServ = {
                                "person_id": $scope.person_id,
                                "token": $scope.token,
                                "arrReboot": $scope.rebotArr
                            };
                            console.log($scope.rbtToServ);
                            var xsrf = { p_clob: JSON.stringify($scope.rbtToServ), p_person_id: $scope.person_id, p_token: $scope.token };
                            $http({
                                    method: 'POST',
                                    url: $scope.appStr3 + '.save_reboot_list',
                                    headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
                                    transformRequest: function(obj) {
                                        var str = [];
                                        for (var p in obj)
                                            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                                        return str.join("&");
                                    },
                                    data: xsrf
                                }).success(function(response) {
                                    console.log(response);
                                    $ionicLoading.hide();
                                    if (response.res == 'Y') {
                                        $scope.init();
                                    } else {
                                        $ionicPopup.alert({
                                            title: 'Невозможно отправить заявку',
                                            content: response.desc
                                        });
                                    }
                                })
                                .error(function(data, status, headers, config) {
                                    console.log(status);
                                    $ionicLoading.hide();
                                })
                        }
                    },
                ]
            });
        }
    })